package com.bofeng.controller;

import com.bofeng.dao.SysAreaMapper;
import com.bofeng.entity.SysArea;
import com.bofeng.entity.Uptown;
import com.bofeng.entity.UptownUnit;
import com.bofeng.service.SysAreaService;
import com.yvan.Model;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
public class WxSysAreaController {

    @Autowired
    private SysAreaService sysAreaService;
    @Autowired
    private SysAreaMapper sysAreaMapper;

    //选择省
    @GetMapping("/admin/selectProvince")
    public Model<List<SysArea>> selectProvince() {
        return Model.newSuccess(sysAreaService.selectProvince());
    }

    //选择城市
    @GetMapping("/admin/selectCityByProvince")
    public Model<List<SysArea>> selectCityByProvince(HttpServletRequest request) {
        Long areaId = Long.parseLong(request.getParameter("areaId"));
        if (areaId == null || areaId == 0L) {
            return Model.newFail("请选择所在省");
        }
        return Model.newSuccess(sysAreaService.selectCityByProvince(areaId));
    }

    //选择区
    @GetMapping("/admin/selectAreaByCity")
    public Model<List<SysArea>> selectAreaByCity(HttpServletRequest request) {
        Long areaId = Long.parseLong(request.getParameter("areaId"));
        if (areaId == null || areaId == 0L) {
            return Model.newFail("请选择所在城市");
        }
        return Model.newSuccess(sysAreaService.selectAreaByCity(areaId));
    }

    //选择小区
    @GetMapping("/admin/selectUptownByArea")
    public Model<List<Uptown>> selectUptownByArea(HttpServletRequest request) {
        Long areaId = Long.parseLong(request.getParameter("areaId"));
        if (areaId == null || areaId == 0L) {
            return Model.newFail("请选择所在区");
        }
        return Model.newSuccess(sysAreaMapper.selectUptownByArea(areaId));
    }

    //选择栋
    @GetMapping("/admin/selectRidgepoleByArea")
    public Model<List<String>> selectRidgepoleByArea(HttpServletRequest request) {
        Long uptownId = Long.parseLong(request.getParameter("uptownId"));
        if (uptownId == null || uptownId == 0L) {
            return Model.newFail("请选择所在小区");
        }
        return Model.newSuccess(sysAreaMapper.selectRidgepoleByArea(uptownId));
    }

    //选择单元
    @GetMapping("/admin/selectUnitByArea")
    public Model<List<UptownUnit>> selectUnitByArea(HttpServletRequest request) {
        Long uptownId = Long.parseLong(request.getParameter("uptownId"));
        Long ridgepole = Long.parseLong(request.getParameter("ridgepole"));
        if (uptownId == null || uptownId == 0L) {
            return Model.newFail("请选择所在小区");
        }
        return Model.newSuccess(sysAreaMapper.selectUnitByArea(uptownId, ridgepole));
    }
}
